#include <SoftwareSerial.h>

SoftwareSerial BT(2,4);
//모터 핀 번호
#define M1A  5
#define M1B  3
#define M2A  10
#define M2B  9

char messege;

void setup() {
  Serial.begin(9600);
  BT.begin(9600);
  pinMode(M1A, OUTPUT);
  pinMode(M1B, OUTPUT);
  pinMode(M2A, OUTPUT);
  pinMode(M2B, OUTPUT);
//모터4개와 블루투스 세팅
}

void loop() {
  while(BT.available()) {
    //Serial.println(messege);
    
    
    messege = BT.read(); //블루투스 통신을 통해 메시지를 받아서 변수에 저장

    switch(messege){  //받은 변수에 따라 동작
      
      case 'F':
      Foward(255);
      break;

      case 'B':
      Back(255);
      break;

      case 'L':
      Left(255);
      break;

      case 'R':
      Right(255);
      break;

      case 'G':
      F_Left(255);
      break;

      case 'I':
      F_Right(255);
      break;

      case 'H':
      B_Left(255);
      break;

      case 'J':
      B_Right(255);
      break;

      case 'S':
      Stop();
      
    }
    
    
   
  }
}

//spd는 속도를 나타냄. 최소 0, 최대 255
void Foward(int spd) { 
  analogWrite(M1A, spd);
  analogWrite(M1B, 0);
  analogWrite(M2A, spd);
  analogWrite(M2B, 0);
//앞으로 전진
  }

void Back (int spd){
  analogWrite(M1A, 0);
  analogWrite(M1B, spd);
  analogWrite(M2A, 0);
  analogWrite(M2B, spd);
//뒤로 후진
}

void F_Right(int spd) {
  analogWrite(M1A, (spd/3));
  analogWrite(M1B, 0);
  analogWrite(M2A, spd);
  analogWrite(M2B, 0);
//우회전(전진하면서)
}

void F_Left(int spd) {
  analogWrite(M1A, spd);
  analogWrite(M1B, 0);
  analogWrite(M2A, (spd/3));
  analogWrite(M2B, 0);
//좌회전(전진하면서)
}
void Left(int spd) {
  analogWrite(M1A, spd);
  analogWrite(M1B, 0);
  analogWrite(M2A, 0);
  analogWrite(M2B, spd);
//좌로 회전
}

void Right(int spd) {
  analogWrite(M1A, 0);
  analogWrite(M1B, spd);
  analogWrite(M2A, spd);
  analogWrite(M2B, 0);
//우로 회전
}

void B_Left(int spd){
  analogWrite(M1A, 0);
  analogWrite(M1B, (spd/2));
  analogWrite(M2A, 0);
  analogWrite(M2B, spd);
//좌후진(후진하면서)
}

void B_Right(int spd){
  analogWrite(M1A, 0);
  analogWrite(M1B, spd);
  analogWrite(M2A, 0);
  analogWrite(M2B, (spd/3));
//우후진(후진하면서)
}

void Stop() {
  analogWrite(M1A, 0);
  analogWrite(M1B, 0);
  analogWrite(M2A, 0);
  analogWrite(M2B, 0);
//정지
}
